<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <link rel="stylesheet" href="ol.css" type="text/css">
    <style>
      .map {
        height: 600px;
        width: 100%;
      }
    </style>
    <script src="ol.js"></script>
    <title>OpenLayers example</title>
  </head>
  <body>
    <h2>My Map</h2>
    <div id="map" class="map"></div>
    <div class="slidecontainer">
      <input type="range" min="0" max="2" value="0" class="slider" id="myRange">
      <p>Date: <span id="date_value"></span></p>
    </div>
    <button id="plymouth">Plymouth</a>
    <button id="boxes">Time Boxes</a>
    <script type="text/javascript">
      var buildingsWithTime = new ol.source.TileWMS({
          url: 'http://localhost:8080/geoserver/wms',
          params: {'LAYERS': 'geonode:building_v2', 'TILED': true, 'TIME': '2022-07-20'},
          serverType: 'geoserver',
          transition: 0,
      })

      var buildingsWithTimeLayer = new ol.layer.Tile({ source: buildingsWithTime });

      var buildings = new ol.source.TileWMS({
          url: 'http://localhost:8080/geoserver/wms',
          params: {'LAYERS': 'geonode:building', 'TILED': true},
          serverType: 'geoserver',
          transition: 0,
      })

      var buildingsLayer = new ol.layer.Tile({ source: buildings });

      var map = new ol.Map({
          target: 'map',
          layers: [ buildingsWithTimeLayer ],
          view: new ol.View()
      });
      
      document.getElementById("plymouth").onclick = setupPlymouthMap;
      document.getElementById("boxes").onclick = setupTimeBoxes;
      setupTimeBoxes();

      function setupPlymouthMap() {
        console.log("showing plymouth");
        var x = ((-4.993268211386456) + (-3.261404209859344)) / 2;
        var y = (50.13282081951258 + 51.014998419178575) / 2;
        map.setLayers([buildingsLayer]);
        map.getView().setCenter(ol.proj.fromLonLat([x, y]));
        map.getView().setZoom(10);
      }

      function setupTimeBoxes() {
        console.log("showing time boxes");
        var x = 3087053715568267;
        var y = 6556213.991577588;
        map.setLayers([buildingsWithTimeLayer]);
        map.getView().setCenter([x, y]);
        map.getView().setZoom(8);
      }

      var dates = [
        '2022-07-05T00:00:00.000Z', 
        '2022-07-06T00:00:00.000Z', 
        '2022-07-07T00:00:00.000Z', 
        '2022-07-08T00:00:00.000Z', 
        '2022-07-09T00:00:00.000Z', 
        '2022-07-10T00:00:00.000Z'
      ]
      var sliderRange = document.getElementById("myRange");
      var dateValue = document.getElementById("date_value");
      sliderRange.max = dates.length-1;
      dateValue.innerHTML = dates[sliderRange.value].slice(0,10);
      buildingsWithTime.updateParams({'TIME': dates[sliderRange.value]});
      // Update the current slider value (each time you drag the slider handle)
      sliderRange.oninput = function() {
        dateValue.innerHTML = dates[this.value].slice(0,10);
        buildingsWithTime.updateParams({'TIME': dates[this.value]});
        console.log(map.getView().getCenter());
      }
    </script>
  </body>
</html>